package com.test;

import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;

import javax.imageio.ImageIO;

import com.alibaba.fastjson.JSONObject;
import com.eyekey.http.EyeKeyHttp;

import Decoder.BASE64Encoder;

/**
 * 人脸检测的Demo
 * @Title: MatchCompareDemo.java
 * @Package: com.test
 * @ClassName: MatchCompareDemo
 * @author Jaylee
 *@date 2015年12月12日 上午11:22:45
 */
public class MatchCompareDemo {
	
	//待比对的图片路径1
	private static String imgPath1="D:\\10.jpg";
	//待比对的图片路径2
	private static String imgPath2="D:\\4.jpg";
	
	public static void main(String[] args) {
		
		File file1=new File(imgPath1);
		File file2=new File(imgPath2);
		
		String face_id1=getFaceidBycheckImg(encodeImgageToBase64(file1));
		String face_id2=getFaceidBycheckImg(encodeImgageToBase64(file2));
		if("".equals(face_id1)){
			System.out.println("第一张图片未检测到人脸");
		}else if( "".equals(face_id2)){
			System.out.println("第二张图片未检测到人脸");
		}else{
			System.err.println("两张图片比对的结果为："+getSimilarityByfaceid(face_id1, face_id2));
		}
	}
	
	/**
	 * 通过base64进行人脸检测
	 * @param base64
	 * @return face_id
	 * @author Jaylee
	 */
	public static String getFaceidBycheckImg(String base64){
		JSONObject json=null;
		EyeKeyHttp e=new EyeKeyHttp();
		json=e.checkingImgB64(base64, null, null);
		System.out.println(json);
		if("0000".equals(json.get("res_code"))){
			return json.getJSONArray("face").getJSONObject(0).get("face_id").toString();
		}else{
			return "";
		}
	}
	
	/**
	 * 比对两个faceid返回相似值
	 * @param face_id1
	 * @param face_id2
	 * @return 比对结果
	 * @author Jaylee
	 */
	public static String getSimilarityByfaceid(String face_id1,String face_id2){
		EyeKeyHttp e=new EyeKeyHttp();
		return e.matchCompare(face_id1, face_id2).toJSONString();
	}
	
	
	/**
	 * File文件转base64格式
	 * @param imageFile
	 * @author Jaylee
	 * @return string
	 */
	 public static String encodeImgageToBase64(File imageFile) {
		 
		 ByteArrayOutputStream outputStream = null;
		    try {
		      BufferedImage bufferedImage = ImageIO.read(imageFile);
		      outputStream = new ByteArrayOutputStream();
		      ImageIO.write(bufferedImage, "jpg", outputStream);
		    } catch (MalformedURLException e1) {
		      e1.printStackTrace();
		    } catch (IOException e) {
		      e.printStackTrace();
		    }
		    BASE64Encoder encoder = new BASE64Encoder();
		    return encoder.encode(outputStream.toByteArray());// 返回Base64编码过的字节数组字符串
	}
	
	
}
